#include <stdio.h>
#include <math.h>
#include <conio.h>

#define R2G 57.29578
#define G2R 0.017453292

struct vector {float s,t;};
struct link   {struct vector j,jv,ja,g,gv,ga; float av,aa;};

void   data(struct link *,struct link *,struct vector *,int *cfg);
void   rep(struct link *,struct link *,struct vector *,int,float);
float  ad(float);
void   svec(struct vector *, struct vector *);
void   accel(struct link *,struct vector *,struct vector *,int);

main()
{ struct vector sl,n; struct link cr,co; int cfg,loop; float d;

sl.s=-4.851; sl.t=24.753;
cr.j.s=15.393; cr.j.t=102.963; cr.av=5.0; cr.aa=20.0;
cr.g.s=1.0; cr.g.t=0.0;
/*cr.g.s=8.347; cr.g.t=-22.225;*/
co.j.s=45.158;
co.g.s=0.0; co.g.t=0.0;
/*co.g.s=23.596; co.g.t=20.453;*/
cfg=1;

/*  data(&cr,&co,&sl,&cfg,&l);*/
  loop=1;
  while(loop){
  cr.j.t*=G2R; sl.t*=G2R; cr.g.t*=G2R; co.g.t*=G2R;
/*posiciones*/
  co.j.t=ad(sl.t-asin((sl.s-cr.j.s*sin(sl.t-cr.j.t))/co.j.s));
  n.s=cr.j.s*cos(sl.t-cr.j.t);
  n.t=sl.s*sl.s+cr.j.s*cr.j.s-co.j.s*co.j.s-2*sl.s*cr.j.s*         \
     cos(cr.j.t-sl.t+M_PI_2);
  d=n.s+cfg*sqrt(n.s*n.s-n.t);
/*velocidades*/
  cr.jv.s=cr.j.s*fabs(cr.av);
  cr.jv.t=ad(cr.av<0?cr.j.t-M_PI_2:cr.j.t+M_PI_2);
  cr.gv.s=cr.g.s*fabs(cr.av);
  cr.gv.t=cr.gv.s==0.0?0.0:ad(cr.jv.t+cr.g.t);
  co.av=(-cr.av*cr.j.s*cos(sl.t-cr.j.t))/(co.j.s*cos(sl.t-co.j.t));
  co.gv.s=co.g.s*fabs(co.av);
  co.gv.t=ad((co.av<0?co.j.t-M_PI_2:co.j.t+M_PI_2)+co.g.t);
  svec(&cr.jv,&co.gv);
  co.jv.s=co.j.s*fabs(co.av);
  co.jv.t=ad((co.av<0?co.j.t-M_PI_2:co.j.t+M_PI_2));
  svec(&cr.jv,&co.jv);
/*aceleraciones*/
  accel(&cr,&cr.j,&cr.ja,0); accel(&cr,&cr.g,&cr.ga,1);
  co.aa=(cr.av*cr.av*cr.j.s*sin(cr.j.t-sl.t)-cr.j.s*cr.aa*cos(cr.j.t-sl.t) \
        +co.j.s*co.av*co.av*sin(co.j.t-sl.t))/(co.j.s*cos(co.j.t-sl.t));
  accel(&co,&co.g,&co.ga,1); svec(&cr.ja,&co.ga);
  accel(&co,&co.j,&co.ja,0); svec(&cr.ja,&co.ja);
  rep(&cr,&co,&sl,cfg,d);
  printf("\n Otro valor del angulo de entrada? [0=no,1=si]: ");
  scanf("%d",&loop);
  if(loop) {printf("\n Valor: "); scanf("%f",&cr.j.t);}    }   }

void accel(struct link *p, struct vector *q, struct vector *r, int k)
{ struct vector n;
  n.s=p->av*p->av*q->s;  n.t=ad(p->j.t+M_PI+k*q->t);
  r->s=fabs(p->aa)*q->s; r->t=ad((p->aa<0?p->j.t-M_PI_2:p->j.t+M_PI_2)+k*q->t);
  svec(&n,r);      }

float ad( float k )
{ int   f, k2;
  f=k<0?-1:1; k2=(int)(fabs(k)/(2.0*M_PI));
  k=f*(fabs(k)-(float)k2*2.0*M_PI); return(k<0?k+=(2.0*M_PI):k); }

void svec(struct vector *a, struct vector *b)
{ float x,y;
  x=a->s*cos(a->t)+b->s*cos(b->t); y=a->s*sin(a->t)+b->s*sin(b->t);
  b->s=sqrt(x*x+y*y); b->t=ad(x<0?atan(y/x)+M_PI:atan(y/x));   }

void data( struct link *cr, struct link *co, struct vector *sl, int *cfg)
{ clrscr();
  printf(" Programa para la solucion cinematica de mecanismos");
  printf(" manivela - corredera\n\n" );
  printf(" Manivela\n");
  printf(" Longitud: " );                        scanf( "%f", &cr->j.s);
  printf(" Angulo: " );                          scanf( "%f", &cr->j.t);
  printf(" Velocidad angular: " );               scanf( "%f", &cr->av);
  printf(" Aceleracion angular: " );             scanf( "%f", &cr->aa);
  printf(" Distancia al centro de gravedad: " ); scanf( "%f", &cr->g.s);
  printf(" Angulo al centro de gravedad: " );    scanf( "%f", &cr->g.t);
  printf("\n Acoplador\n");
  printf(" Longitud: " );                        scanf( "%f", &co->j.s);
  printf(" Distancia al centro de gravedad: " ); scanf( "%f", &co->g.s);
  printf(" Angulo al centro de gravedad: " );    scanf( "%f", &co->g.t);
  printf("\n Corredera\n");
  printf(" Defasamiento: " );                    scanf( "%f", &sl->s);
  printf(" Inclinacion : " );                    scanf( "%f", &sl->t);
  printf("\n Configuracion [1:abierta, -1:cruzada]: " ); scanf( "%d", cfg );}

void rep(struct link *cr,struct link *co,struct vector *sl,int cfg,float d)
{ clrscr();
  printf("           *****   Datos   *****\n\n");
  printf(" Manivela\n");
  printf(" Longitud: %.3f, angulo: %.3f\n",cr->j.s, cr->j.t*R2G);
  printf(" Vel. ang: %e, Acel. ang.: %e\n",cr->av,cr->aa);
  printf(" CG, distancia: %.3f, angulo: %.3f\n\n",cr->g.s,cr->g.t*R2G);
  printf(" Acoplador\n");
  printf(" Longitud: %.3f\n", co->j.s);
  printf(" CG, distancia: %.3f, angulo: %.3f\n\n",co->g.s,co->g.t*R2G);
  printf(" Corredera\n");
  printf(" Desplazamiento: %.3f\n",sl->s);
  printf(" Inclinacion   : %.3f\n\n",sl->t*R2G);
  if(cfg==1) printf(" Configuracion: abierta\n\n");
    else printf(" Configuracion: cruzada\n\n");
  getchar();getchar();
  clrscr();
  printf("           *****   Resultados   *****\n\n" );
  printf(" Manivela\n");
  printf(" Angular    : pos.: %.3f, vel.: %e, acel.: %e\n",     \
         cr->j.t*R2G,cr->av,cr->aa);
  printf(" Cen. grav. : velocidad  : %.3f, angulo: %.3f\n",     \
         cr->gv.s,cr->gv.t*R2G);
  printf("              aceleracion: %.3f, angulo: %.3f\n",     \
         cr->ga.s,cr->ga.t*R2G);
  printf(" Junta A    : velocidad  : %.3f, angulo: %.3f\n",     \
         cr->jv.s,cr->jv.t*R2G);
  printf("              aceleracion: %.3f, angulo: %.3f\n\n",   \
         cr->ja.s,cr->ja.t*R2G);
  printf(" Acoplador\n");
  printf(" Angular    : pos.: %.3f, vel.: %e, acel.: %e\n",     \
         co->j.t*R2G,co->av,co->aa);
  printf(" Cen. grav. : velocidad  : %.3f, angulo: %.3f\n",     \
         co->gv.s,co->gv.t*R2G);
  printf("              aceleracion: %.3f, angulo: %.3f\n\n",   \
         co->ga.s,co->ga.t*R2G);
  printf(" Corredera\n");
  printf(" Distancia  : %.3f\n",d);
  printf(" Velocidad  : %.3f, angulo: %.3f\n",co->jv.s,co->jv.t*R2G);
  printf(" Aceleracion: %.3f, angulo: %.3f\n\n",co->ja.s,co->ja.t*R2G);
  printf("\n   Programa realizado por: Romy Perez Moreno\n");
  printf("   Comentarios: romy@fenix.uam.mx romy@correo.azc.uam.mx\n");
  getchar();   }

